# log4cplus::TTCCLayout Class Reference

TTCC layout format consists of time, thread, Logger and nested diagnostic context information, hence the name. More...

`#include <layout.h>`

Inheritance diagram for log4cplus::TTCCLayout:

[legend]
Collaboration diagram for log4cplus::TTCCLayout:

[legend]
List of all members.

## Public Member Functions

| TTCCLayout (bool use_gmtime=false)
| TTCCLayout (const log4cplus::helpers::Properties &properties)
virtual | ~TTCCLayout ()
virtual void | formatAndAppend (log4cplus::tostream &output, const log4cplus::spi::InternalLoggingEvent &event)

## Protected Attributes

log4cplus::tstring | dateFormat
bool | use_gmtime

## Detailed Description

TTCC layout format consists of time, thread, Logger and nested diagnostic context information, hence the name.

The time format depends on the `DateFormat` used. Use the `Use_gmtime` to specify whether messages should be logged using `localtime` or `gmtime`.

Here is an example TTCCLayout output with the RelativeTimeDateFormat.

     176 [main] INFO  org.apache.log4j.examples.Sort - Populating an array of 2 elements in reverse order.
     225 [main] INFO  org.apache.log4j.examples.SortAlgo - Entered the sort method.
     262 [main] DEBUG org.apache.log4j.examples.SortAlgo.OUTER i=1 - Outer loop.
     276 [main] DEBUG org.apache.log4j.examples.SortAlgo.SWAP i=1 j=0 - Swapping intArray[0] = 1 and intArray[1] = 0
     290 [main] DEBUG org.apache.log4j.examples.SortAlgo.OUTER i=0 - Outer loop.
     304 [main] INFO  org.apache.log4j.examples.SortAlgo.DUMP - Dump of interger array:
     317 [main] INFO  org.apache.log4j.examples.SortAlgo.DUMP - Element [0] = 0
     331 [main] INFO  org.apache.log4j.examples.SortAlgo.DUMP - Element [1] = 1
     343 [main] INFO  org.apache.log4j.examples.Sort - The next log statement should be an error message.
     346 [main] ERROR org.apache.log4j.examples.SortAlgo.DUMP - Tried to dump an uninitialized array.
     467 [main] INFO  org.apache.log4j.examples.Sort - Exiting main method.

The first field is the number of milliseconds elapsed since the start of the program. The second field is the thread outputting the log statement. The third field is the LogLevel, the fourth field is the logger to which the statement belongs.

The fifth field (just before the '-') is the nested diagnostic context. Note the nested diagnostic context may be empty as in the first two statements. The text after the '-' is the message of the statement.

PatternLayout offers a much more flexible alternative.

Definition at line 127 of file layout.h.

## Constructor & Destructor Documentation

log4cplus::TTCCLayout::TTCCLayout | ( | bool | use_gmtime = false | ) |

log4cplus::TTCCLayout::TTCCLayout | ( | const log4cplus::helpers::Properties & | properties | ) |

virtual log4cplus::TTCCLayout::~TTCCLayout | ( |  | ) | `[virtual]`

## Member Function Documentation

virtual void log4cplus::TTCCLayout::formatAndAppend | ( | log4cplus::tostream & | output,
|  | const log4cplus::spi::InternalLoggingEvent & | event
| ) | `[virtual]`

| Implements log4cplus::Layout.

## Member Data Documentation

log4cplus::tstring log4cplus::TTCCLayout::dateFormat`[protected]`

| Definition at line 138 of file layout.h.

bool log4cplus::TTCCLayout::use_gmtime`[protected]`

| Definition at line 139 of file layout.h.

The documentation for this class was generated from the following file:

- layout.h